import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends Canvas implements MouseListener,MouseMotionListener, KeyListener {
    String STRING;
    TextArea A,B;
    SelectInteger SI,TESTDEPTH;
    ListenSquare[][] WEIGHT=new ListenSquare[6][20];
    ListenSquare[][] PATTERN=new ListenSquare[6][3];
    String[] SHOW=new String[5];
    int[] OFFSET=new int[5];
    int REDUNDANT;
    int HEIGHT,MAXWIDTH;
    StringSearch[] CURRENT=new StringSearch[1000];
    SelectInteger RELATION,INSTANCE;
    int START_REL;
    ListenSquare TEST,STOP;
    ControlPanel GLOBAL,TESTMODE;
    String PROGRESS;
    ComputeTest CT;
    int N1;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setControls();
	 setControlPanels();
	 CT=new ComputeTest();
	 N1=367;
     }


    public void setControlPanels() {	 
         Color[] C0={new Color(50,100,255),Color.white,Color.white,Color.black,Color.red};
         Color[] C1={new Color(200,10,200),Color.white,Color.white,Color.black,Color.red};

	 //global
	 String[] GlobalString={"normal", "relations", "mode"};
	 int[] GlobalState={1,0};
                  GLOBAL=new ControlPanel(C1,GlobalString,GlobalState,2);

	 //relation tester
	 String[] TestmodeString={"losers", "winners", "test"};
	 int[] TestmodeState={1,0};
                  TESTMODE=new ControlPanel(C0,TestmodeString,TestmodeState,2);

    }


    public void setControls() {
	 STRING="";

	 for(int j=0;j<4;++j) {
	 for(int i=0;i<15;++i) {
                 WEIGHT[j][i]=new ListenSquare(45+80*j,117+30*i,15,15,null);
	         WEIGHT[j][i].on=0;
	 }}
	 RELATION=new SelectInteger(110,45,40,20,0,0,18,1);
	 INSTANCE=new SelectInteger(210,45,40,20,0,0,15,1);
	 TEST=new ListenSquare(360+100,0,60,20,null);TEST.on=1;
	 STOP=new ListenSquare(360+160,0,60,20,null);STOP.on=1;
	 TESTDEPTH=new SelectInteger(360+100,25,40,20,2,2,8,1);
	 for(int i=0;i<4;++i) SHOW[i]="";
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBg(g);    
      drawControls(g);
      drawWeights(g);
      drawTotal(g);
   }



    public void drawControls(Graphics2D g) {
     g.setColor(new Color(0,80,80));
     g.fillRect(N1,80,getWidth(),getHeight());    
      g.setColor(Color.white);
      g.setStroke(new BasicStroke(2));
     g.drawLine(0,0,getWidth(),0);
     g.drawLine(0,80,getWidth(),80);
     g.drawLine(N1,0,N1,getHeight());
      g.setFont(new Font("Helvetica",Font.PLAIN,12));

      for(int j=0;j<4;++j) {
	  for(int i=0;i<15;++i) {
	      WEIGHT[j][i].render(g,Color.blue,Color.yellow);
	  }
      }      
     g.setStroke(new BasicStroke(1));

           Color C=Color.magenta;
           RELATION.render(g,C,Color.white,Color.white);
           INSTANCE.render(g,C,Color.white,Color.white);
           g.setColor(Color.white);    
           g.setFont(new Font("Helvetica",Font.PLAIN,12));
          g.drawString("relations",110,30);
          g.drawString("instances",210,30);    
          TEST.render(g,Color.red);
          TESTDEPTH.render(g,Color.red,Color.white,Color.white);
          g.drawString("test",N1+100,15);
          if(CT.halt==1) g.drawString("stop",N1+160,15);
          TESTMODE.render(g,N1,0,80);   
          if(CT.halt==1) STOP.render(g,Color.blue);
    }


    public void drawComments(Graphics2D g) {
       if(START_REL!=0) {
                  g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(new Color(100,200,255));
	g.drawString("REMARKS:",622,30);
	if(RELATION.val<5) g.drawString("trivial, useful for induction",622,47);
	if(RELATION.val==5) g.drawString("trivial, useful for slicing cyclic at aba",622,47);
	if(RELATION.val==6) g.drawString("trivial, useful for slicing cyclic at axa",622,47);
	if(RELATION.val==7) g.drawString("trivial, useful for slicing cyclic at xx",622,47);
	if(RELATION.val==8) g.drawString("nontrivial, useful for proving cyclic identity 11",622,47);
	if(RELATION.val==9) g.drawString("nontrivial, useful for proving cyclic identity 12",622,47);

	if(RELATION.val==10) g.drawString("nontrivial, cyclic case: eliminate b",622,47);
	if(RELATION.val==11) g.drawString("nontrivial, cyclic case: eliminate x",622,47);

	if(RELATION.val==12) g.drawString("trivial, unnecessary",622,47);
	if(RELATION.val==13) g.drawString("trivial, unnecessary",622,47);
	if(RELATION.val>=14) g.drawString("nontrivial, unnecessary",622,47);
       }
    }



    public void drawBg(Graphics2D g) {
	g.setColor(Color.black);
                  g.fillRect(0,0,getWidth(),getHeight()); 
	g.setColor(new Color(80,0,80));
	g.fillRect(0,0,getWidth(),80);
	g.setColor(new Color(40,0,120));
	g.fillRect(N1,0,getWidth(),80);
	g.setColor(new Color(0,0,200));
	for(int i=0;i<16;++i) {
	    g.drawLine(0,110+30*i,N1,110+30*i);
	}
    }

    public void drawTotal(Graphics2D g) {    
	g.setColor(Color.white);	
	g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.drawString(STRING,10,60);
	HEIGHT=0;
	MAXWIDTH=0;
	StringProcess X=StringProcess.extract(A.getText(),B.getText());

	for(int i=0;i<X.count;++i) {
	    try {
	          String TEMP=X.S[i];
	           int N=X.s[i];
	           OFFSET[i]=-X.t[i];
                             CURRENT=StringSearch.fullList(TEMP);
                             drawNumbers(g,N,TEMP,12+80*i,80,Color.yellow);
                             drawMatches(g,i,N,TEMP,N1,80);
	    }
	    catch(Exception e) {}
	}

    }

    public void testRelation() {   
	CT=new ComputeTest(this); 
                   new Thread(CT).start();
    }



    public void getRelation(Point X) {
	RELATION.modifyCyclic(X);
	if(RELATION.isModified(X)==1) {

	    Relation RR=Relation.getRelation(RELATION.val);
	    A.setText("");
	    A.insert(RR.R,0);
	    for(int i=0;i<3;++i) {
		Integer TEMP=new Integer(1);
		SHOW[i]=TEMP.toString();
		//OFFSET[i]=RR.offset[i];
	    }
	    if(RR.length==2) SHOW[2]="";
	}
    }



    public void getInstance(Point X) {
	INSTANCE.modifyCyclic(X);
	if((INSTANCE.isModified(X)==1)||(RELATION.isModified(X)==1)) {
	    for(int i=0;i<15;++i) {
		for(int j=0;j<4;++j) {
		    WEIGHT[j][i].on=0;
		}
	    }
	    int v=INSTANCE.val;
	    try{
	    WEIGHT[0][v].on=1;

	    if(SHOW[1]!="") {
		int k1=OFFSET[1];
		WEIGHT[1][v+k1].on=1;
	    }

	    if(SHOW[2]!="") {
		int k2=OFFSET[2];
		WEIGHT[2][v+k2].on=1;
	    }
	    }
	    catch(Exception e) {}
	}
    }


    public void drawNumbers(Graphics2D g, int n,String string,int x,int y,Color C) {
	int count=0;     
	g.translate(x,y);
                  g.setFont(new Font("Helvetica",Font.PLAIN,12));
	for(int w=0;w<15;++w) {
	   Integer W=new Integer(n*totalCoeff(CURRENT,w));
                     g.setColor(C);
	   g.drawString(W.toString(),60,50+30*count);
	   ++count;
	}
	g.translate(-x,-y);
    }

    public void drawWeights(Graphics2D g) {
                  g.setFont(new Font("Helvetica",Font.PLAIN,12));
	for(int w=0;w<15;++w) {
	    Integer W=new Integer(w);
	    g.setColor(new Color(50,100,255));
	   g.drawString(W.toString(),10,130+30*w);	   
	}
    }


    public void drawMatches(Graphics2D g, int choice,int n,String string,int x,int y) {
	int offset=0;
	if(choice==1) HEIGHT=0;
	if(choice>0) offset=MAXWIDTH+50;
	g.translate(x+offset,y+HEIGHT);

	int count=0;     
	Color[] C={Color.yellow,Color.white};

	Font F=new Font("Helvetica",Font.PLAIN,12);
	g.setFont(F);
	 int max=getFontWidth(g,CURRENT);
	 if(MAXWIDTH<max) MAXWIDTH=max;

	for(int w=0;w<15;++w) {
	    if((WEIGHT[choice][w].on==1)&&(checkNonzero(CURRENT,w)==true)) {
	      Integer W=new Integer(w);
       	     g.setColor(new Color(50,100,255));
       	     Integer X=new Integer(choice);
	     g.setColor(new Color(0,200,200));
	     g.drawLine(10,20*count+30,MAXWIDTH+30,20*count+30);
       	      g.setColor(Color.white);
	    for(int i=0;i<CURRENT.length;++i) {
	         if(CURRENT[i].termWeight()==w) {
	         CURRENT[i].renderLeft(g,n,10,30,45+20*count,C);
	         ++count;
	      }
	    }
	}
	}
	   
	g.translate(-x-offset,-y-HEIGHT);

	HEIGHT=HEIGHT+20*count;
    }


    public int getFontWidth(Graphics2D g,StringSearch[] LIST,int w) {
	  int max=0;      
	  for(int i=0;i<LIST.length;++i) {
	      if(LIST[i].termWeight()==w) {
		  int wid=LIST[i].getWidth(g);
		  if(max<wid) max=wid;
	      }
	  }
	  return(max);
    }

    public int getFontWidth(Graphics2D g,StringSearch[] LIST) {
	  int max=0;      
	  for(int i=0;i<LIST.length;++i) {
	     int wid=LIST[i].getWidth(g);
	     if(max<wid) max=wid;
	  }
	  return(max);
    }


    public boolean checkNonzero(StringSearch[] LIST,int w) {
	  for(int i=0;i<LIST.length;++i) {
	      if(LIST[i].termWeight()==w) return(true);
	  }
	  return(false);
    }

    public int totalCoeff(StringSearch[] LIST,int w) {
	int c=0;
	  for(int i=0;i<LIST.length;++i) {
	      if(LIST[i].termWeight()==w) {
		  c=c+LIST[i].termCoeff();
	      }
	  }
	  return(c);
    }

    public void selectWeights(Point X) {
	for(int j=0;j<4;++j) {
	for(int i=0;i<15;++i) {
	    if(WEIGHT[j][i].inside(X)==1) WEIGHT[j][i].on=1-WEIGHT[j][i].on;
	}}
    }

    
    public void mousePressed(MouseEvent e) {
        MouseData J=MouseData.process(e);
    }

    public void mouseClicked(MouseEvent e) {
	MouseData J=MouseData.process(e);
	selectWeights(J.X);
	   getRelation(J.X);
	   getInstance(J.X);	
                     if(TEST.inside(J.X)==1) testRelation();
	   TESTDEPTH.modify(J.X);
	   TESTMODE.switchMode(J.X);
	   if(STOP.inside(J.X)==1) CT.halt=0;
	   repaint();
    }
    
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {
     } 


    public void keyTyped(KeyEvent e) {}


    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}


}

