import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

public class StringSearch {
    String[] S=new String[2];
    int sign;
    int cyclic;


    public StringSearch() {}

    public StringSearch(String T) {
	S[0]=new String(T);
	S[1]="";
    }

    public StringSearch(StringSearch T) {
	S[0]=new String(T.S[0]);
	S[1]=new String(T.S[1]);
    }

    public void print() {
	int c=this.termCoeff();
	int w=this.termWeight();
	System.out.print(S[0]+"    "+S[1]+"            "+w+" "+c);
	System.out.println("");
    }


    public void renderLeft(Graphics2D g,int n,int x0,int x1,int y,Color[] C) {
	g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(C[0]);

	String Q=new String("");
	Integer W=new Integer(n*termCoeff());
	g.drawString(W.toString(),x0,y);
	g.setColor(C[1]);
	for(int i=0;i<S[1].length();++i) {
	    Q=Q+" "+block(extract(i))+" ";
	}
	g.drawString(Q,x1,y);
    }


    public void renderRight(Graphics2D g,int x0,int x1,int y,Color[] C) {
	g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(C[0]);
	FontMetrics FM=g.getFontMetrics();

	String Q=new String("");
	Integer W=new Integer(termCoeff());
	g.drawString(W.toString(),x0,y);
	g.setColor(C[1]);
	for(int i=0;i<S[1].length();++i) {
	    Q=Q+" "+block(extract(i))+" ";
	}
	int wid=FM.stringWidth(Q);
	g.drawString(Q,30+x1-wid,y);
    }



    public int getWidth(Graphics2D g) {
                    FontMetrics FM=g.getFontMetrics();
	  String Q="";
	for(int i=0;i<S[1].length();++i) {
	    Q=Q+" "+block(extract(i))+" ";
	}
	return(FM.stringWidth(Q));
    }

    public static String reverse(String S) {
	String T=new String("");
	int n=S.length();
	for(int i=0;i<n;++i) {
	    T=T+S.substring(n-i-1,n-i);
	}
	return(T);
    }

    public static String block(int k) {	
                  if(k==0) return("X");
	if(k==1) return("XAA");
	if(k==2) return("XA");	
                  if(k==3) return("AXA");
	if(k==4) return("AAA");
	if(k==5) return("ABA");
	if(k==6) return("XXA");
	if(k==7) return("BA");
	return("");
    }

    public static int weight(String S) {
	if(S.equals("AXA")==true) return(2);
	if(S.equals("XAA")==true) return(1);
	if(S.equals("XA")==true) return(1);
	if(S.equals("X")==true) return(1);
	if(S.equals("AAA")==true) return(-1);
	if(S.equals("ABA")==true) return(-1);
	if(S.equals("XXA")==true) return(-1);
	if(S.equals("BA")==true) return(-1);
	return(0);
    }

    public int checkGood() {
	int w=0;
	for(int i=0;i<S[1].length()-1;++i) {
	    int i1=this.extract(i);
	    int i2=this.extract(i+1);
	    if((i1==0)&&(i2==2)) return(0);
	    if((i1==0)&&(i2==7)) return(0);
	}
	return(1);
    }





    public int extract(int i) {
	    Integer I=new Integer(S[1].substring(i,i+1));
	    return(I.intValue());
    }


    public int termWeight() {
	int w=0;
	for(int i=0;i<S[1].length();++i) {
	    if(this.extract(i)>0) ++w;
	}
	return(w);
    }

    public int termCoeff() {
	int w=1;
	for(int i=0;i<S[1].length();++i) {
	    w=w*weight(block(extract(i)));
	}
	w=w*this.checkGood();
	return(w);
    }


    public static boolean canStart(String S,int k) {
	String T=block(k);
	return(S.startsWith(T));
    }

    public static int[] doesStart(String S) {
	int[] yes=new int[8];
	int count=0;
	for(int k=0;k<8;++k) {
	    if(canStart(S,k)==true) {
		yes[count]=k;
		++count;
	    }
	}
	int[] yes2=new int[count];
	for(int i=0;i<count;++i) yes2[i]=yes[i];
	return(yes2);
    }


    public static StringSearch[] cutStart(StringSearch S) {
	StringSearch[] T=new StringSearch[8];
	int count=0;
	for(int i=0;i<8;++i) {
	    if(canStart(S.S[0],i)==true) {
		String U=block(i);
		T[count]=new StringSearch();
		T[count].S[0]=S.S[0].substring(U.length(),S.S[0].length());
		Integer I=new Integer(i);
		T[count].S[1]=S.S[1]+I.toString();
		++count;
	    }
	}

	StringSearch[] T2=new StringSearch[count];
	for(int i=0;i<count;++i) T2[i]=new StringSearch(T[i]);
	return(T2);
    }

    public static StringSearch[] fullList(String S) {
	char x=S.charAt(0);
	if(x=='[') return(fullListClosed(S.substring(1,S.length())));
	if(x=='(') return(fullListCyclic(S));
	return(fullListClosed("XX"+S));
    }


    public static StringSearch[] fullListCyclic(String S) {
	String S1=new String(S.substring(1,S.length()));
	String S2=StringProcess.rotateRight(S1);
	String S3=StringProcess.rotateRight(S2);

	StringSearch[] X1=fullListClosed(S1);
	StringSearch[] X2=fullListClosed(S2);
	StringSearch[] X3=fullListClosed(S3);

	int c1=X1.length;
	int c2=X2.length;
	int c3=X3.length;

	int cc=c1+c2+c3;

	if(S1.equals(S2)==true) {c2=0;}
	//	if(S1.equals(S3)==true) {c3=0;}
	if(S2.equals(S3)==true) {c3=0;}


	StringSearch[] XX=new StringSearch[cc];
	int count=0;

	for(int i=0;i<c1;++i) {    
                     if(X1[i].good0()==true) {
	    XX[count]=new StringSearch(X1[i]);
	   ++count;
	   }
	}

	for(int i=0;i<c2;++i) {
	    if(X2[i].good1()==true) {
                          XX[count]=new StringSearch(X2[i]);
	       ++count;
	    }
	}

	for(int i=0;i<c3;++i) {
	    if(X3[i].good2()==true) {
                          XX[count]=new StringSearch(X3[i]);
	       ++count;
	    }
	}

	StringSearch[] YY=new StringSearch[count];
	for(int i=0;i<count;++i) YY[i]=new StringSearch(XX[i]);
	return(YY);
    }

    public boolean good0() {
	char x0=this.S[1].charAt(0);
	char x1=this.S[1].charAt(S[1].length()-1);
	if((x0=='7')&&(x1=='0')) return(false);
	if((x0=='2')&&(x1=='0')) return(false);
	return(true);
    }



     public boolean good1() {
	 if(this.good0()==false) return(false);
                  char x0=this.S[1].charAt(0);
	if(x0=='0') return(false);
	return(true);
    }

    public boolean good2() {
	if(this.good0()==false) return(false);
	char x0=this.S[1].charAt(0);	
	if(x0=='0') return(false);
	if(x0=='2') return(false);
	if(x0=='7') return(false);
	return(true);
    }





    public static StringSearch[] fullListClosed(String STRING) {
	StringSearch[] Y=new StringSearch[1000];
	StringSearch SUCCESS[]=new StringSearch[1000];
	int count=1;
	int success=0;
	Y[0]=new StringSearch(STRING);

	while(count>0) {
	    StringSearch CURRENT=new StringSearch(Y[count-1]);
	    if(CURRENT.S[0].length()==0) {
                                 --count;
	               if(CURRENT.checkGood()==1) {
	               SUCCESS[success]=new StringSearch(CURRENT);
	               ++success;
	       }
	    }
	    if(CURRENT.S[0].length()>0) {
		StringSearch[] Z=cutStart(CURRENT);
		for(int i=count-1;i<count+Z.length-1;++i) {
		    Y[i]=new StringSearch(Z[i-count+1]);
		}
		count=count+Z.length-1;
	    }
	}

	StringSearch[] S2=new StringSearch[success];
	for(int i=0;i<success;++i) S2[i]=new StringSearch(SUCCESS[i]);
	return(S2);
    }




}